//----------------------------------------------------------------------------
// Math2.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Math2.pas
//----------------------------------------------------------------------------
#ifndef Math2HPP
#define Math2HPP
//----------------------------------------------------------------------------
#include <Vector.hpp>
#include <Matrix.hpp>
#include <Math1.hpp>
#include <DCommon.hpp>
#include <System.hpp>
namespace Math2
{
//-- type declarations -------------------------------------------------------
typedef Byte CombiType[256];

class __declspec(delphiclass) TCurveFit;
class __declspec(pascalimplementation) TCurveFit : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	double sumx;
	double sumy;
	double sumxq;
	double sumyq;
	double sumDiff;
	double SumDiffq;
	double sumxy;
	double sumx2y;
	double sumx3;
	double sumx4;
	double sum1byy;
	double sum1byyq;
	double sumxbyy;
	double sumybyx;
	double sum1byx;
	double sum1byxq;
	double sumlnx;
	double sumlnxq;
	double sumylnx;
	double sumlny;
	double sumlnyq;
	double sumxlny;
	double sumxqlny;
	long FNumData;
	double __fastcall GetMeanX(void);
	double __fastcall GetMeanY(void);
	double __fastcall GetStdDevX(void);
	double __fastcall GetStdDevY(void);
	double __fastcall GetMeanDiff(void);
	double __fastcall GetStdDevDiff(void);
	double __fastcall GetRxy(void);
	
public:
	__fastcall TCurveFit(void);
	__fastcall virtual ~TCurveFit(void);
	void __fastcall Init(void);
	void __fastcall EnterStatValue(double p0, double p1);
	void __fastcall CalcStatistics(long &p0, double &p1, double &p2, double &p3, double &p4, double &p5
		, double &p6, double &p7);
	void __fastcall CalcGaussFit(double &p0, double &p1, double &p2, double &p3);
	void __fastcall CalcLinFit(double &p0, double &p1, double &p2);
	void __fastcall CalcLogFit(double &p0, double &p1, double &p2);
	void __fastcall CalcParabolFit(double &p0, double &p1, double &p2, double &p3);
	void __fastcall CalcReciLinFit(double &p0, double &p1, double &p2);
	void __fastcall CalcHyperbolFit(double &p0, double &p1, double &p2);
	__property long NumData = {read=FNumData, nodefault};
	__property double MeanX = {read=GetMeanX};
	__property double MeanY = {read=GetMeanY};
	__property double StdDevX = {read=GetStdDevX};
	__property double StdDevY = {read=GetStdDevY};
	__property double MeanDiff = {read=GetMeanDiff};
	__property double StdDevDiff = {read=GetStdDevDiff};
	__property double CorrCoeff = {read=GetRxy};
};

//-- var, const, procedure ---------------------------------------------------
extern long ProcStat;
extern Dcommon::FeedBackProcType MathFeedBackProc;
extern double __fastcall nDistri(double p0);
extern double __fastcall nDistriQuantile(double p0);
extern double __fastcall tDistriQuantile(double p0, int p1);
extern bool __fastcall CalcCovar(Matrix::TMatrix* p0, Matrix::TMatrix* p1, int p2, int p3, int p4, int 
	p5, int p6);
extern bool __fastcall CalcEigVec(Matrix::TMatrix* p0);
extern double __fastcall GetEigenResult(int p0, int p1);
extern void __fastcall RemoveEigenMatrix(void);
extern bool __fastcall CalcPrincComp(Matrix::TMatrix* p0, int p1, int p2, int p3, int p4, int p5);
extern double __fastcall CalcFishQ(double p0, double p1, double p2, double p3);
extern void __fastcall MeanDistanceKNN(Matrix::TMatrix* p0, int p1, int p2, int p3, Vector::TVector* 
	&p4);
extern void __fastcall FindCenters(Matrix::TMatrix* p0, int p1, int p2, int p3, Matrix::TMatrix* &p4
	, double &p5);
extern void __fastcall FindNearestNeighbors(int p0, Matrix::TMatrix* p1, int p2, int p3, Vector::TVector* 
	p4, Matrix::TMatrix* p5);
extern double __fastcall CalcGaussKernel(Vector::TVector* p0, Vector::TVector* p1, double p2);
extern double __fastcall CalcGaussKernelMat(Vector::TVector* p0, Matrix::TMatrix* p1, int p2, double 
	p3);

}	/* namespace Math2 */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Math2;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Math2
