//----------------------------------------------------------------------------
// Matrix.hpp - bcbdcc32 generated hdr (DO NOT EDIT) rev: 0
// From: Matrix.pas
//----------------------------------------------------------------------------
#ifndef MatrixHPP
#define MatrixHPP
//----------------------------------------------------------------------------
#include <Dialogs.hpp>
#include <Vector.hpp>
#include <DCommon.hpp>
#include <System.hpp>
namespace Matrix
{
//-- type declarations -------------------------------------------------------
class __declspec(delphiclass) TMatrix;
class __declspec(pascalimplementation) TMatrix : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	long FNCol;
	long FNRow;
	void *Mat;
	int FPrecis[2];
	double __fastcall GetVal(long p0, long p1);
	void __fastcall SetVal(long p0, long p1, double p2);
	int __fastcall GetFPrecis(int p0);
	void __fastcall SetFPrecis(int p0, int p1);
	
public:
	__fastcall TMatrix(long p0, long p1);
	__fastcall virtual ~TMatrix(void);
	__property double Elem[long ix][long iy] = {read=GetVal, write=SetVal};
	bool __fastcall Add(TMatrix* p0);
	void __fastcall CopyFrom(TMatrix* p0, int p1, int p2, int p3, int p4, int p5, int p6);
	void __fastcall CopyFromVec(Vector::TVector* p0, int p1, int p2, int p3, int p4);
	void __fastcall Fill(double p0);
	HIDESBASE void __fastcall Free(void);
	bool __fastcall Invert(void);
	bool __fastcall LoadFromFile( System::AnsiString p0);
	__property long NrOfColumns = {read=FNCol, nodefault};
	__property long NrOfRows = {read=FNRow, nodefault};
	__property int Precision[int Index] = {read=GetFPrecis, write=SetFPrecis};
	void __fastcall MeanVar(int p0, int p1, int p2, int p3, double &p4, double &p5);
	double __fastcall Median(int p0, int p1, int p2, int p3);
	void __fastcall MinMax(int p0, int p1, int p2, int p3, double &p4, double &p5);
	bool __fastcall Multiply(TMatrix* p0, TMatrix* p1);
	bool __fastcall Resize(int p0, int p1);
	void __fastcall SkewKurt(int p0, int p1, int p2, int p3, double &p4, double &p5);
	void __fastcall SMult(double p0);
	void __fastcall SortCols(int p0, bool p1, int p2, int p3, int p4, int p5);
	void __fastcall SortRows(int p0, bool p1, int p2, int p3, int p4, int p5);
	bool __fastcall StoreOnFile(int p0, int p1, int p2, int p3,  System::AnsiString p4);
	bool __fastcall Subtract(TMatrix* p0);
	bool __fastcall Transpose(void);
};

class __declspec(delphiclass) TIntMatrix;
class __declspec(pascalimplementation) TIntMatrix : public System::TObject
{
	typedef System::TObject inherited;
	
private:
	long FNCol;
	long FNRow;
	void *Mat;
	int __fastcall GetVal(long p0, long p1);
	void __fastcall SetVal(long p0, long p1, int p2);
	
public:
	__fastcall TIntMatrix(long p0, long p1);
	__fastcall virtual ~TIntMatrix(void);
	__property int Elem[long ix][long iy] = {read=GetVal, write=SetVal};
	bool __fastcall Add(TIntMatrix* p0);
	void __fastcall CopyFrom(TIntMatrix* p0, int p1, int p2, int p3, int p4, int p5, int p6);
	void __fastcall Fill(int p0);
	bool __fastcall LoadFromFile( System::AnsiString p0);
	__property long NrOfColumns = {read=FNCol, nodefault};
	__property long NrOfRows = {read=FNRow, nodefault};
	void __fastcall MeanVar(int p0, int p1, int p2, int p3, double &p4, double &p5);
	int __fastcall Median(int p0, int p1, int p2, int p3);
	void __fastcall MinMax(int p0, int p1, int p2, int p3, int &p4, int &p5);
	bool __fastcall Multiply(TIntMatrix* p0, TIntMatrix* p1);
	bool __fastcall Resize(int p0, int p1);
	void __fastcall SkewKurt(int p0, int p1, int p2, int p3, double &p4, double &p5);
	void __fastcall SMult(int p0);
	void __fastcall SortCols(int p0, bool p1, int p2, int p3, int p4, int p5);
	void __fastcall SortRows(int p0, bool p1, int p2, int p3, int p4, int p5);
	bool __fastcall StoreOnFile(int p0, int p1, int p2, int p3,  System::AnsiString p4);
	bool __fastcall Subtract(TIntMatrix* p0);
	bool __fastcall Transpose(void);
};

//-- var, const, procedure ---------------------------------------------------

}	/* namespace Matrix */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Matrix;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// Matrix
